Imports System.Text
Imports System.IO

Public Class Form1
    Private Declare Auto Function GetPrivateProfileString Lib "Kernel32" ( _
        ByVal lpAppName As String, _
        ByVal lpKeyName As String, _
        ByVal lpDefault As String, _
        ByVal lpReturnedString As StringBuilder, _
        ByVal nSize As Integer, _
        ByVal lpFileName As String) As Integer
    Private Declare Auto Function WritePrivateProfileString Lib "Kernel32" ( _
        ByVal lpAppName As String, _
        ByVal lpKeyName As String, _
        ByVal lpString As String, _
        ByVal lpFileName As String) As Integer

    ' Load the previously saved position.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim ini_file_name As String = IniFileName
        Dim l As Integer = Integer.Parse(GetIniString(ini_file_name, "Position", "Left", "100"))
        Dim t As Integer = Integer.Parse(GetIniString(ini_file_name, "Position", "Top", "100"))
        Dim w As Integer = Integer.Parse(GetIniString(ini_file_name, "Position", "Width", "400"))
        Dim h As Integer = Integer.Parse(GetIniString(ini_file_name, "Position", "Height", "300"))
        Me.SetBounds(l, t, w, h)
    End Sub

    ' Make using GetPrivateProfileString a little easier.
    Private Function GetIniString(ByVal file_name As String, ByVal section_name As String, ByVal key_name As String, ByVal default_value As String) As String
        Const MAX_LENGTH As Integer = 500
        Dim string_builder As New StringBuilder(MAX_LENGTH)
        GetPrivateProfileString(section_name, key_name, default_value, string_builder, MAX_LENGTH, file_name)
        Return string_builder.ToString()
    End Function

    ' Save the current position.
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim ini_file_name As String = IniFileName()
        WritePrivateProfileString("Position", "Left", Me.Left.ToString(), ini_file_name)
        WritePrivateProfileString("Position", "Top", Me.Top.ToString(), ini_file_name)
        WritePrivateProfileString("Position", "Width", Me.Width.ToString(), ini_file_name)
        WritePrivateProfileString("Position", "Height", Me.Height.ToString(), ini_file_name)
    End Sub

    ' Return the INI file's name.
    Private Function IniFileName() As String
        Dim ini_file_name As String = Application.StartupPath
        ini_file_name = ini_file_name.Substring(0, ini_file_name.LastIndexOf("\"))
        ini_file_name = ini_file_name.Substring(0, ini_file_name.LastIndexOf("\"))
        Return ini_file_name & "\UseIniFile.ini"
    End Function
End Class
